;Ahk_Now by Joe df
;29th December 2012 - started
#SingleInstance, Off
version=1.3
A_Now_Script=
running=false
A_Self_PID:=DllCall("GetCurrentProcessId")
A_Self=ahk_pid %A_Self_PID%
SetBatchLines -1
OnExit, out
;------------------------------------
;Gui, font, wItalic
Gui, Add, Edit, x3 y3 w292 h245 vAhk_code_box, 
Gui, Add, Button, x209 y250 w44 h22 gClean, Clean
Gui, Add, Button, x253 y250 w44 h22 gRun vrun_button, Run
Gui, Add, Text, x5 y272 w298 h15 c404040 vStatus_text, Status: Paused
Gui, Add, Checkbox, x3 y250 h22 gtogglePin, Pin
Gui, Add, Slider, x35 y248 w175 h24 vTransparencySlider AltSubmit gTransparency Range2-255 NoTicks, 255
Gui, Show, Center w298 h290, Ahk_Now v%version% by Joe DF
enableGuiDrag()
Return

GuiSize:

return

Run:
If (running = "false")
{
	GuiControl, Disable, run_button
	GuiControlGet, ahk_code,, Ahk_code_box
	A_Now_Script = %A_Temp%/%A_Now%_A_Now.ahk
	GuiControl,, Status_text, Status: Writing script %A_Now_Script%
	FileAppend, %ahk_code%, %A_Now_Script%
	Run, %A_Now_Script%,,, A_Now_PID
	GuiControl,, Status_text, Status: Running with PID %A_Now_PID%
	GuiControl,, run_button, Kill
	GuiControl, Enable, run_button
	SetTimer, check_run_status, 10
	running=true
}
Else
{
	gosub, Kill
}
return

Kill:
GuiControl, Disable, run_button
SetTimer, check_run_status, Off
GuiControl,, Status_text, Status: Killing Script with PID %A_Now_PID%
Process, Close, %A_Now_PID%
if ErrorLevel = 0
{
	GuiControl,, Status_text, Status: Paused
	GuiControl,, run_button, Run
	GuiControl, Enable, run_button
	running=false
}
else
{
	goto kill ;try again...
}
return

Clean:
gosub, Kill
GuiControl,, Status_text, Status: Cleaning...
FileDelete, %A_Temp%\*_A_Now.ahk
GuiControl,, Status_text, Status: Paused and Clean
return

check_run_status:
Process, Exist, %A_Now_PID%
if ErrorLevel = 0
{
	SetTimer, check_run_status, Off
	GuiControl,, Status_text, Status: Paused
	GuiControl,, run_button, Run
	running=false
}
return

togglePin:
Winset, Alwaysontop, , %A_Self%
return

Transparency:
GuiControlGet,Trans,,TransparencySlider
WinSet,Trans,%Trans%
return

enableGuiDrag(GuiLabel=1) {
	WinGetPos,,,A_w,A_h,A
	Gui, %GuiLabel%:Add, Text, x0 y0 w%A_w% h%A_h% +BackgroundTrans gGUI_Drag
	return
	
	GUI_Drag:
	PostMessage 0xA1,2  ;-- Goyyah/SKAN trick
	;http://autohotkey.com/board/topic/80594-how-to-enable-drag-for-a-gui-without-a-titlebar
	return
}

out:
GuiClose:
gosub, Clean
ExitApp
return
