﻿
; //Initialization
; ------------------------------------------
#NoTrayIcon
#NoEnv
;#SingleInstance, Force
SetBatchLines,-1
AppTarget=SciTE ;WinTitle
AppName=%A_ScriptName%
AppVersion=1.0.0
AppError=
AppAuthor=Joe DF
AppRevision=April 5th, 2013 at 20:24
AppSwitches=-,/
SetTitleMatchMode, 2
; ------------------------------------------


; //Parse Command Line Parameters
; ------------------------------------------
argc=%0%
if (argc > 0)
{
	Loop, %0%  ; For each parameter:
	{
		param := %A_Index%  ; Fetch the contents of the variable whose name is contained in A_Index.
		#IfWinActive ahk_class SciTEWindow
		execute(param) ;Parameter number %A_Index% is %param%.
	}
	Goto AppExit
}
Else
{
	Goto AppExit
}
; ------------------------------------------


; //Labels & Operations
; ------------------------------------------
save:
WinMenuSelectItem, %AppTarget%, Source, &File, &Save
return

code:
fold:
WinMenuSelectItem, %AppTarget%, Source, &View, Toggle &all folds
Return

console:
output:
WinMenuSelectItem, %AppTarget%, Source, &View, Output
Return

find:
replace:
fnr:
WinMenuSelectItem, %AppTarget%, Source, &Search, Replace...
Return

insertdate:
send, %A_Hour%:%A_Min% %A_YYYY%/%A_MM%/%A_DD%
return

Stop_Executing:
stop_execution:
kill:
WinMenuSelectItem, %AppTarget%, Source, &Tools, Stop Executing
return

quickrun:
gosub Save
WinMenuSelectItem, %AppTarget%, Source, &Tools, Quick run
return
; ------------------------------------------


; //Functions
; ------------------------------------------
execute(alias) {
	global AppSwitches
	global AppErrors
	switch:=SubStr(alias,1,1)
	if IsLabel(alias)
	{
		Gosub, %alias%
	}
	else if switch in %AppSwitches%
	{
		alias_b:=SubStr(alias,2)
		execute(alias_b)
	}
	Else
	{
		AppErrors=%AppError%"%alias%"`n
	}
}
; ------------------------------------------

AppExit:
if AppError =
{
	ExitApp
}
Else
{
	MsgBox, 64, %A_ScriptName%, The following terms`nwere not understood...`n%AppError%
	ExitApp
}
Return

